RCS "$Id: MuCalculusProtected.sig,v 1.9 1998/08/13 11:38:54 pxs Exp $";
(* See MuCalculus.sig. This is the more permissive version of that sig. *)
signature MU_CALCULUS_PROTECTED =
sig
  structure M : MODALITY_COMPLEX_PROTECTED

   datatype param = Modparam of M.modality
                   | Propparam of prop

        and prop = True
                  | False
                  | Var of V.var * param list
                  | Not of prop
                  | And of prop * prop
                  | Or of prop * prop
                  | Imp of prop * prop
                  | Nec of M.modality * prop
                  | Pos of M.modality * prop
                  | WeakNec of M.modality * prop
                  | WeakPos of M.modality * prop
                  | Max of V.var * prop
                  | Min of V.var * prop
     
   val printStringParam : param -> string
   val printString : prop -> string

   val parameq : param * param -> bool
   val propeq : prop * prop -> bool
end

